! Synthetic marine data tape movie generation
program Syncmp

  use sep
  use syncmp_mod

  implicit none
  real, allocatable, dimension(:,:,:) :: data
  integer                             :: nt, nh, ny, nz
  real                                :: maxamp, maxdelay

  call sep_init()                   ! Initialize I/O module "sep"

  call from_param("nt", nt, 250)
  call from_param("nh", nh, 48)
  call from_param("ny", ny, 10)
  call from_param("nz", nz, 25)
  call from_param("maxdelay", maxdelay, 5.)
  call from_param("maxamp", maxamp, .5)

  call to_history("n1", nt)         ! Output data dimensions
  call to_history("n2", nh)
  call to_history("n3", ny)

  allocate(data(nt, nh, ny))
  data = 0.

  !maxamp = maxamp/10.
  call syncmp1(data, nt, nh, ny, nz, maxamp, maxdelay)
  call sep_write(data)              ! Write output to disk

  call sep_close()

end program

