! Synthetic marine data tape movie generation
program Synmarine

  use sep
  use synmarine_mod

  implicit none
  real, allocatable, dimension(:,:,:) :: data
  integer                             :: nt, nh, ny, nz

  call sep_init()                   ! Initialize I/O module "sep"

  call from_param("nt", nt, 250)
  call from_param("nh", nh, 48)
  call from_param("ny", ny, 10)
  call from_param("nz", nz, 25)

  call to_history("n1", nt)         ! Output data dimensions
  call to_history("n2", nh)
  call to_history("n3", ny)

  allocate(data(nt, nh, ny))
  data = 0.

  call synmarin(data, nt, nh, ny, nz)
  call sep_write(data)              ! Write output to disk

end program
