program build_gaussian_cdf

  use sep
  use stats_mod

  implicit none

  real                               :: rand,o_cdf,d_cdf,o_samp,d_samp,p_min,p_max,test,mean,avg,sig
  integer                            :: n1,n2,i,j,n_cdf,nb_picks
  real,dimension(:,:),allocatable    :: data
  real,dimension(:),allocatable      :: cdf,x_test

  call sep_init()

  call from_history("n1",n1)
  call from_history("n2",n2)
  call from_param("o_cdf",o_cdf)
  call from_param("d_cdf",d_cdf)
  call from_param("n_cdf",n_cdf)

  write(0,*) "o", o_cdf
  write(0,*) "d", d_cdf
  write(0,*) "n", n_cdf

  allocate(data(n1,n2))
  allocate(cdf(n_cdf))

  call sep_read(data)

  avg = average(data)
  sig = stand_dev(data,avg)
  write(0,*) "average input", avg
  write(0,*) "sigma input", sig
  cdf = gaussian_cdf(o_cdf,d_cdf,n_cdf,avg,sig)

  p_min = cdf(1)
  p_max = cdf(n_cdf)

  write(0,*),"p min",p_min
  write(0,*),"p max",p_max

  call to_history("n1",n_cdf)
  call to_history("o1",o_cdf)
  call to_history("d1",d_cdf)

  call to_history("n2",1)
  call to_history("o2",0.0)
  call to_history("d2",0.0)
  
  call sep_write(cdf)

  call sep_close() 

end program
