program build_and_plot_cdf

  use sep
  use stats_mod

  implicit none

  integer                                 :: ntau,nv,ncmp,i,j,flag,p,depth
  real                                    :: otau,dtau,ov,dv,ocmp,dcmp
  real,dimension(:,:),allocatable         :: semblance
  real,dimension(:),allocatable           :: min_vel_allowed,max_vel_allowed
  real                                    :: slope_min,slope_max,tau
  real                                    :: min_t1,min_t2,min_v1,min_v2,max_t1,max_t2,max_v1,max_v2,harvest
  real,dimension(:,:),allocatable         :: matrix,inverse
  real,dimension(:,:),allocatable         :: ident
  real,dimension(:,:),allocatable         :: mat,inv_mat,id_mat
  real,dimension(:),allocatable           :: cdf

 
  call sep_init()

  call from_history("n1", ntau) 
  call from_history("o1", otau)
  call from_history("d1", dtau)
  call from_history("n2", nv) 
  call from_history("o2", ov)
  call from_history("d2", dv)

  call from_param("depth",depth)

  !call from_param("cdf_type",cdf_type)
  !call from_param("min_t1",min_t1)
  !call from_param("min_v1",min_v1)
  !call from_param("min_t2",min_t2)
  !call from_param("min_v2",min_v2)
  !call from_param("max_t1",max_t1)
  !call from_param("max_v1",max_v1)
  !call from_param("max_t2",max_t2)
  !call from_param("max_v2",max_v2)

  allocate(semblance(ntau,nv))
  call sep_read(semblance)

  allocate(cdf(nv))

!  do i=1,ntau
!    tau=otau + (i-1)*dtau
!    slope_min = (min_v2-min_v1)/(min_t2-min_t1)  
!    slope_max = (max_v2-max_v1)/(max_t2-max_t1)      
!    min_vel_allowed(i) = slope_min*(tau-min_t1)+min_v1
!    max_vel_allowed(i) = slope_max*(tau-max_t1)+max_v1
!  end do

    !do j=1,ntau
      cdf = raw_cdf(semblance(depth,:),ov,dv,ov,ov+(ntau-1)*dtau)
    !end do
  !else
  !  do j=1,ntau
  !    cdf(j,:) = build_gaussian_cdf(semblance(j,:),ov,dv,min_vel_allowed(j),max_vel_allowed(j))
  !  end do
  !end if
  do i=1,nv
    write(0,*) "cdf",i,cdf(i)
  end do

  call to_history("n1",nv)
  call to_history("d1",dv)
  call to_history("o1",ov)
  call to_history("n2",1)
  call to_history("o2",0)
  call to_history("d2",0)
  call to_history("label1","Velocity (Km/s)")
  call to_history("label2","Cumulative probability")

  call sep_write(cdf)

  call sep_close()

end program
