program cdf_matrix

  use sep
  use stats_mod

  implicit none

  integer                               :: ntau,nv,i,j,itau,ind,pp
  real                                  :: otau,dtau,ov,dv,mean_mean,mean_var,test
  real,dimension(:,:),allocatable       :: detrended_semblance,coord_detrend,cdf
  integer,dimension(:),allocatable      :: length
  real,dimension(:),allocatable         :: mean,var,total_weight

  call sep_init()

  call from_history("n1",ntau)
  call from_history("o1",otau)
  call from_history("d1",dtau)
  call from_history("n2",nv)
  call from_history("o2",ov)
  call from_history("d2",dv)
 
  call from_param("itau",itau)

  allocate(detrended_semblance(ntau,nv))
  allocate(coord_detrend(ntau,3))
  allocate(length(ntau))
  allocate(mean(ntau))
  allocate(var(ntau))
  allocate(total_weight(ntau))

  call sep_read(detrended_semblance)
  call sep_read(coord_detrend,"coord")

  do i=1,ntau
    length(i) = coord_detrend(i,2)
  end do

  mean = 0
  var = 0
  total_weight = 0

  do i=1,ntau
    total_weight(i) = sum(detrended_semblance(i,1:length(i)))
    do j=1,length(i)
      mean(i) = mean(i) + detrended_semblance(i,j) * (coord_detrend(i,1)+(j-1)*coord_detrend(i,3))
    end do
    mean(i) = mean(i)/total_weight(i)
  end do

  do i=1,ntau
    total_weight(i) = sum(detrended_semblance(i,1:length(i)))
    do j=1,length(i)
      var(i) = var(i) + detrended_semblance(i,j) * (coord_detrend(i,1)+(j-1)*coord_detrend(i,3) - mean(i))**2
    end do
    var(i) = var(i) / total_weight(i)
  end do

  mean_mean = 0
  mean_var  = 0
  do i=1,ntau
    mean_mean = mean_mean + mean(i)
    mean_var  = mean_var  +  var(i)
  end do
  mean_mean = mean_mean / ntau
  mean_var = mean_var / ntau

  write(0,*) "mean of mean",mean_mean
  write(0,*) "mean of var",mean_var
  write(0,*) "max var",maxval(var)

  allocate(cdf(ntau,nv))
  write(0,*) "nv",nv

  cdf = 0

  do i=1,ntau
    cdf(i,1:length(i)) = raw_cdf(detrended_semblance(i,1:length(i)),coord_detrend(i,1),coord_detrend(i,3),coord_detrend(i,1),coord_detrend(i,1) + (length(i)-1)*coord_detrend(i,3)) 
  end do
  ind = 30
  !pp = size(detrended_semblance(ind,1:length(ind)))
  write(0,*) "pp",length(ind)
  
  test = mc_gaussian(cdf(ind,1:length(ind)),coord_detrend(ind,1),coord_detrend(ind,3),length(ind))
  write(0,*) "test",test

  call sep_write(cdf)
  call to_history("n1",ntau)
  call to_history("o1",otau)
  call to_history("d1",dtau)
  call to_history("n2",nv)
  call to_history("o2",1)
  call to_history("d2",1)

  call sep_write(cdf(itau,:),"plot_cdf")
  call to_history("n1",length(itau),"plot_cdf")
  call to_history("o1",coord_detrend(itau,1),"plot_cdf")
  call to_history("d1",coord_detrend(itau,3),"plot_cdf")
  call to_history("n2",1,"plot_cdf")
  call to_history("o2",0,"plot_cdf")
  call to_history("d2",0,"plot_cdf")

  call sep_write(detrended_semblance(itau,:),"plot_density")
  call to_history("n1",length(itau),"plot_density")
  call to_history("o1",coord_detrend(itau,1),"plot_density")
  call to_history("d1",coord_detrend(itau,3),"plot_density")
  call to_history("n2",1,"plot_density")
  call to_history("o2",0,"plot_density")
  call to_history("d2",0,"plot_density")

  call sep_write(mean,"mean")
  call to_history("n1",ntau,"mean")
  call to_history("o1",otau,"mean")
  call to_history("d1",dtau,"mean")
  call to_history("n2",1,"mean")
  call to_history("o2",0,"mean")
  call to_history("d2",0,"mean")

  call sep_write(var,"var")
  call to_history("n1",ntau,"var")
  call to_history("o1",otau,"var")
  call to_history("d1",dtau,"var")
  call to_history("n2",1,"var")
  call to_history("o2",0,"var")
  call to_history("d2",0,"var")


  call sep_close()    

end program
