module cov_mod
! simple matrix multiplication

  implicit none

  integer, private                             :: n
  real,dimension(:,:),allocatable,private      :: matrix 
  
  contains

  subroutine cov_init(n_in,matrix_in)
    integer                            :: n_in
    real,dimension(:,:)                :: matrix_in
    allocate(matrix(n_in,n_in))
    matrix = matrix_in
    n = n_in
  end subroutine

  function cov_op(adj,add,model,data) result(stat)
    logical,intent(in)   :: adj, add
    real,dimension(:)    :: model, data
    integer              :: stat
    call cov_op2(adj,add,model,data)
    stat=0
  end function

  subroutine cov_op2(adj,add,model,data)
    logical,intent(in)       :: adj,add
    real,dimension(n)        :: data,model
    integer                  :: i,j
 
    if (adj) then
      if (add .eqv. .false.) model = 0.
      do i=1,n
        do j=1,n
          model(j) = model(j) + matrix(i,j) * data(i) 
        end do
      end do

     else 
       if(add .eqv. .false.) data = 0.
       do i=1,n
         do j=1,n
           data(i) = data(i) + matrix(i,j) * model(j)
         end do
       end do
     end if

  end subroutine

end module
