program detrend

  use sep
  use stats_mod

  implicit none

  integer                               :: ntau,nv,i,j,new_nv,ind1,ind2
  real                                  :: otau,dtau,ov,dv,new_min_vel,new_max_vel
  real,dimension(:),allocatable         :: trend,new_ov,max_v
  real,dimension(:,:),allocatable       :: muted_semblance
  real,dimension(:),allocatable         :: cap_index_temp,floor_index_temp,peak_index_temp,velocities,velocities2
  integer,dimension(:),allocatable      :: cap_index,floor_index,length,peak_index
  real,dimension(:),allocatable         :: semb1,semb2
  real,dimension(:,:),allocatable       :: coord_detrend,detrended_semblance
  real                                  :: origin,increment,vel_min,vel_max
  real,dimension(:,:),allocatable       :: cdf_matrix

  call sep_init()

  call from_history("n1",ntau)
  call from_history("o1",otau)
  call from_history("d1",dtau)
  call from_history("n2",nv)
  call from_history("o2",ov)
  call from_history("d2",dv)

  allocate(length(ntau))
  allocate(trend(ntau))
  allocate(new_ov(ntau))
  allocate(max_v(ntau))
  allocate(muted_semblance(ntau,nv))
  allocate(cap_index(ntau))
  allocate(floor_index(ntau))
  allocate(cap_index_temp(ntau))
  allocate(floor_index_temp(ntau))

  call sep_read(muted_semblance)
  call sep_read(floor_index_temp,"floor_index")
  call sep_read(cap_index_temp,"cap_index")
  call sep_read(trend,"trend")
  call sep_read(velocities2,"rough_trend")

  cap_index = cap_index_temp
  floor_index = floor_index_temp

  do i=1,ntau
    length(i) = cap_index(i) - floor_index(i) + 1
    new_ov(i) = ov + (floor_index(i)-1)*dv - trend(i)
    write(0,*) "new o",i,new_ov(i)
    max_v(i) = new_ov(i) + (length(i)-1)*dv
  end do

  new_nv = maxval(length)

  allocate(detrended_semblance(ntau,new_nv))
  allocate(coord_detrend(ntau,3))
  allocate(cdf_matrix(ntau,new_nv))

  detrended_semblance = 0
  cdf_matrix = 0

  do i=1,ntau
    coord_detrend(i,1)=new_ov(i)
    coord_detrend(i,2)=length(i)
    coord_detrend(i,3)=dv
    do j=1,length(i)
      detrended_semblance(i,j) = muted_semblance(i,j+floor_index(i)-1)
    end do
  end do 

  do i=1,ntau
    cdf_matrix(i,1:length(i)) = raw_cdf(detrended_semblance(i,1:length(i)),coord_detrend(i,1),coord_detrend(i,3),coord_detrend(i,1),coord_detrend(i,1) + (length(i)-1)*coord_detrend(i,3)) 
  end do

  call sep_write(detrended_semblance)
  call to_history("n1",ntau)
  call to_history("o1",otau)
  call to_history("d1",dtau)
  call to_history("n2",new_nv)
  call to_history("o2",1)
  call to_history("d2",1)

  call sep_write(cdf_matrix,"cdf_matrix")
  call to_history("n1",ntau,"cdf_matrix")
  call to_history("o1",otau,"cdf_matrix")
  call to_history("d1",dtau,"cdf_matrix")
  call to_history("n2",new_nv,"cdf_matrix")
  call to_history("o2",1,"cdf_matrix")
  call to_history("d2",1,"cdf_matrix")

  call sep_write(coord_detrend,"coord_detrend")
  call to_history("n1",ntau,"coord_detrend")
  call to_history("o1",1,"coord_detrend")
  call to_history("d1",1,"coord_detrend")
  call to_history("n2",3,"coord_detrend")
  call to_history("o2",1,"coord_detrend")
  call to_history("d2",1,"coord_detrend")

  call sep_close()    

end program
