program detrend_2d

  use sep
  use stats_mod

  implicit none

  integer                               :: ntau,nv,ncmp,i,j,k,new_nv,ind1,ind2
  real                                  :: otau,dtau,ov,dv,ocmp,dcmp,new_min_vel,new_max_vel
  real,dimension(:,:),allocatable       :: trend,new_ov,max_v
  real,dimension(:,:,:),allocatable     :: muted_semblance
  real,dimension(:,:),allocatable       :: cap_index_temp,floor_index_temp,peak_index_temp,velocities,velocities2
  integer,dimension(:,:),allocatable    :: cap_index,floor_index,length,peak_index
  real,dimension(:,:,:),allocatable     :: coord_detrend,detrended_semblance
  real                                  :: origin,increment,vel_min,vel_max
  real,dimension(:,:,:),allocatable     :: cdf_matrix

  call sep_init()

  call from_history("n1",ntau)
  call from_history("o1",otau)
  call from_history("d1",dtau)
  call from_history("n2",nv)
  call from_history("o2",ov)
  call from_history("d2",dv)
  call from_history("n3",ncmp)
  call from_history("o3",ocmp)
  call from_history("d3",dcmp)

  allocate(length(ntau,ncmp))
  allocate(trend(ntau,ncmp))
  allocate(new_ov(ntau,ncmp))
  allocate(max_v(ntau,ncmp))
  allocate(muted_semblance(ntau,nv,ncmp))
  allocate(cap_index(ntau,ncmp))
  allocate(floor_index(ntau,ncmp))
  allocate(cap_index_temp(ntau,ncmp))
  allocate(floor_index_temp(ntau,ncmp))

  call sep_read(muted_semblance)
  call sep_read(floor_index_temp,"floor_index")
  call sep_read(cap_index_temp,"cap_index")
  call sep_read(trend,"trend")
  call sep_read(velocities2,"rough_trend")

  cap_index = cap_index_temp
  floor_index = floor_index_temp

  do j=1,ncmp
    do i=1,ntau
      length(i,j) = cap_index(i,j) - floor_index(i,j) + 1
      new_ov(i,j) = ov + (floor_index(i,j)-1)*dv - trend(i,j)
      !write(0,*) "new o",i,new_ov(i,j)
      max_v(i,j) = new_ov(i,j) + (length(i,j)-1)*dv
    end do
  end do

  new_nv = maxval(length)

  allocate(detrended_semblance(ntau,new_nv,ncmp))
  allocate(coord_detrend(ntau,3,ncmp))
  allocate(cdf_matrix(ntau,new_nv,ncmp))

  detrended_semblance = 0
  cdf_matrix = 0

  do k=1,ncmp
    do i=1,ntau
      coord_detrend(i,1,k)=new_ov(i,k)
      coord_detrend(i,2,k)=length(i,k)
      coord_detrend(i,3,k)=dv
      do j=1,length(i,k)
        detrended_semblance(i,j,k) = muted_semblance(i,j+floor_index(i,k)-1,k)
      end do
    end do 
  end do

  do j=1,ncmp
    do i=1,ntau
      cdf_matrix(i,1:length(i,j),j) = raw_cdf(detrended_semblance(i,1:length(i,j),j),coord_detrend(i,1,j),coord_detrend(i,3,j),coord_detrend(i,1,j),coord_detrend(i,1,j) + (length(i,j)-1)*coord_detrend(i,3,j)) 
      !cdf_matrix(i,1:length(i,j),j) = 0.
    end do
  end do

  call sep_write(detrended_semblance)
  call to_history("n1",ntau)
  call to_history("o1",otau)
  call to_history("d1",dtau)
  call to_history("n2",new_nv)
  call to_history("o2",1)
  call to_history("d2",1)
  call to_history("n3",ncmp)
  call to_history("o3",ocmp)
  call to_history("d3",dcmp)

  call sep_write(cdf_matrix,"cdf_matrix")
  call to_history("n1",ntau,"cdf_matrix")
  call to_history("o1",otau,"cdf_matrix")
  call to_history("d1",dtau,"cdf_matrix")
  call to_history("n2",new_nv,"cdf_matrix")
  call to_history("o2",1,"cdf_matrix")
  call to_history("d2",1,"cdf_matrix")
  call to_history("n3",ncmp,"cdf_matrix")
  call to_history("o3",ocmp,"cdf_matrix")
  call to_history("d3",dcmp,"cdf_matrix")

  call sep_write(coord_detrend,"coord_detrend")
  call to_history("n1",ntau,"coord_detrend")
  call to_history("o1",1,"coord_detrend")
  call to_history("d1",1,"coord_detrend")
  call to_history("n2",3,"coord_detrend")
  call to_history("o2",1,"coord_detrend")
  call to_history("d2",1,"coord_detrend")
  call to_history("n3",ncmp,"coord_detrend")
  call to_history("o3",ocmp,"coord_detrend")
  call to_history("d3",dcmp,"coord_detrend")

  call sep_close()    

end program
