program detrended_cdf

  use sep
  use stats_mod

  implicit none

  integer                                :: itau,ntau,nv,i,size_cdf
  real,dimension(:,:),allocatable        :: detrended_semblance,coord_detrend
  real,dimension(:),allocatable          :: cdf

  call sep_init()

  call from_history("n1",ntau)
  call from_history("n2",nv)
 
  allocate(detrended_semblance(ntau,nv))
  allocate(coord_detrend(ntau,3))

  call sep_read(detrended_semblance)
  call sep_read(coord_detrend,"coord")

  call from_param("itau",itau)

  size_cdf = coord_detrend(itau,2)
  allocate(cdf(size_cdf))
  cdf = 0  

  write(0,*) "size cdf",size_cdf
  write(0,*) "o1",coord_detrend(itau,1)
  write(0,*) "d1",coord_detrend(itau,3)

  cdf = raw_cdf(detrended_semblance(itau,1:size_cdf),coord_detrend(itau,1),coord_detrend(itau,3),coord_detrend(itau,1),coord_detrend(itau,1)+(size_cdf-1)*coord_detrend(itau,3)) 

  call sep_write(cdf)

  call to_history("n1",size_cdf)
  call to_history("o1",coord_detrend(itau,1))
  call to_history("d1",coord_detrend(itau,3))
  call to_history("n2",1)
  call to_history("o2",0)
  call to_history("d2",0)

  call sep_close()

end program
