program plot_density

  use sep

  implicit none

  integer                                :: itau,ntau,nv,i,size_density
  real,dimension(:,:),allocatable        :: detrend_semblance,coord_detrend
  real,dimension(:),allocatable          :: density

  call sep_init()

  call from_history("n1",ntau)
  call from_history("n2",nv)
 
  allocate(detrend_semblance(ntau,nv))
  allocate(coord_detrend(ntau,3))

  call sep_read(detrend_semblance)
  call sep_read(coord_detrend,"coord")

  call from_param("itau",itau)

  size_density = coord_detrend(itau,2)
  allocate(density(size_density))
  density = 0  

  write(0,*) "size density",size_density
  write(0,*) "o",coord_detrend(itau,1)
  write(0,*) "d",coord_detrend(itau,3)

  do i=1,size_density
    density(i) = detrend_semblance(itau,i)
  end do
  
  call sep_write(density)

  call to_history("n1",size_density)
  call to_history("o1",coord_detrend(itau,1))
  call to_history("d1",coord_detrend(itau,3))
  call to_history("n2",1)
  call to_history("o2",0)
  call to_history("d2",0)

  call sep_close()

end program
