program dot_test_guillaume

  use sep
  use vel_analysis_mod

  implicit none
  real,dimension(:,:),allocatable   :: xtilda,ytilda,x,y
  integer                           :: nt,nx,nv,i,j,iseed
  real                              :: xscalar,yscalar,rand01,ot,ox,ov,dt,dx,dv,temp

  call sep_init()

  ! enter my parameters
  nt=1000
  nx=24
  nv=100
  ot=0.
  ox=0.264
  ov=1.450
  dt=0.004
  dx=0.134
  dv=0.017

  ! x is the model (tau,v) space
  ! y is the data (time,offset) space

  allocate(x(nt,nv),xtilda(nt,nv))
  allocate(y(nt,nx),ytilda(nt,nx))

  iseed=1993
  do i=1,nt
    do j=1,nv
      call random_number(temp)
      x(i,j)=iseed
    end do
  end do

  do i=1,nt
    do j=1,nx
      call random_number(temp)
      y(i,j)=iseed
    end do
  end do

  ! calling the forward operator     
  call vel_analysis(0,ot,dt,nt,ox,dx,nx,ov,dv,nv,x,ytilda) 
  ! calling the adjoint
  call vel_analysis(1,ot,dt,nt,ox,dx,nx,ov,dv,nv,xtilda,y)
 
  ! doing the dot product (multiplying term by term)
  xscalar=0.
  yscalar=0.
  
  do i=1,nt
    do j=1,nv
      xscalar = xscalar + x(i,j)*xtilda(i,j)
    end do
  end do

  do i=1,nt
    do j=1,nx
      yscalar = yscalar + y(i,j)*ytilda(i,j)
    end do
  end do  
  
  write(0,*) 'xscalar=',xscalar,'yscalar=',yscalar

  call sep_close()

end program
