module exp_cov_mod

  implicit none
  
  contains

  ! this function builds a covariance function exponential model (we need to input our parameters though) and calculates the correlation for a specific distance (assuming isotropy and stationarity)
  function get_covariance(distance,nugget,range,sill,alpha,power) result(covariance)
    real :: distance,nugget,range,sill,covariance,c1,alpha,power
 
    c1 = sill - nugget
    if (distance .eq. 0.) then
      covariance = sill
    else 
      covariance = (sill - nugget)*exp(-alpha*(abs(distance)/range)**power)
    end if
  end function

end module
