! this program creates an exponential covariance model
program exponential_covariance

  use exp_cov_mod
  use sep
 
  implicit none
  
  real                                    :: distance,nugget,range,sill,alpha,power
  real,dimension(:,:),allocatable         :: covariance_funct
  integer                                 :: i,n1
  real                                    :: o1,d1
  real,dimension(:),allocatable           :: raw_covariance,nb_sample_range

  call sep_init()

  call from_history("n1",n1)
  call from_history("o1",o1)
  call from_history("d1",d1)

  call from_param("nugget",nugget)
  call from_param("range_variogram",range)
  call from_param("sill",sill)
  call from_param("alpha",alpha)
  call from_param("power",power)

  allocate(covariance_funct(n1,2))
  allocate(raw_covariance(n1))
  call sep_read(raw_covariance)

  allocate(nb_sample_range(n1))
  do i=1,n1
    nb_sample_range(i) = o1 + (i-1) * d1
  end do

  do i=1,n1    
    covariance_funct(i,1) = get_covariance(nb_sample_range(i),nugget,range,sill,alpha,power)
    covariance_funct(i,2) = raw_covariance(i)      
  end do

  write(0,*) "sill",raw_covariance(1)

  call sep_write(covariance_funct)

  call to_history("n1",n1)
  call to_history("o1",o1)
  call to_history("d1",d1)

  call to_history("n2",2)
  call to_history("o2",1)
  call to_history("d2",1)

  call sep_close()
  
end program

