program generate_random

  use sep
  use stats_mod

  implicit none

  real                               :: ot,dt,ox,dx,perc,x_coord,rand_nb,t_coord,mean,sigma
  integer                            :: nt,nx,n,init_n,i,j,nb_to_generate,nb,temp
  real,dimension(:,:),allocatable    :: model,flag
  real,dimension(:,:),allocatable    :: initial_samples

  call sep_init()

  call from_param("nt",nt)
  call from_param("ot",ot)
  call from_param("dt",dt)

  call from_param("ncmp",nx)
  call from_param("ocmp",ox)
  call from_param("dcmp",dx)

  call from_param("perc",perc)

  allocate(model(nt,nx))
  allocate(flag(nt,nx))
  model = 0
  flag = 0
  
  n = nt * nx
  nb_to_generate = perc/100 * n
  nb = 0

  allocate(initial_samples(nb_to_generate,1))
  initial_samples = 0.
  temp = 0
  
  do while ( nb .lt. nb_to_generate )
      call random_number(rand_nb)
      call random_number(rand_nb)
      x_coord = ox + (rand_nb)*(nx-1)*dx
      j = 1.5 + (x_coord-ox)/dx

      call random_number(rand_nb)
      call random_number(rand_nb)
      t_coord = ot + (rand_nb)*(nt-1)*dt
      i = 1.5 + (t_coord-ot)/dt

      if (flag(i,j) .eq. 0) then
        flag(i,j) = 1
        nb = nb + 1
        temp = temp + 1
        call random_number(rand_nb)
        call random_number(rand_nb)
        model(i,j) = rand_nb
        initial_samples(temp,1) = model(i,j)
      end if  
  end do    

  mean = average(initial_samples)
  sigma = stand_dev(initial_samples,mean)

  write(0,*) "mean",mean
  write(0,*) "variance",sigma
  write(0,*) "size model",n
  write(0,*) "nb to generate",nb_to_generate

  call sep_write(model)
  call sep_write(flag,"flag")

  call to_history("n1",nt)
  call to_history("o1",ot)
  call to_history("d1",dt)
  call to_history("n2",nx)
  call to_history("o2",ox)
  call to_history("d2",dx)

  call to_history("n1",nt,"flag")
  call to_history("o1",ot,"flag")
  call to_history("d1",dt,"flag")
  call to_history("n2",nx,"flag")
  call to_history("o2",ox,"flag")
  call to_history("d2",dx,"flag")

  call sep_close()

end program
