module invert_matrix_mod
! this module inverts a Fm=d (inverts for m) using either steepest descent or conjugate gradient

  use solver_mod
  use sdstep_mod
  use cgstep_mod
  use mat_mult_mod
  implicit none

  contains

  subroutine invert_matrix(mat,model,data,niter)
    real,dimension(:,:)       :: mat
    real,dimension(:)         :: model,data
    integer                   :: n,niter
    n = size(mat,1)
    call mat_mult_init(n,mat)
    !call solver_tiny(model,data,mat_mult_op,sdstep,niter)
    call solver_tiny(model,data,mat_mult_op,cgstep,niter)
    call dealloc_matrix()
  end subroutine

end module

