module make_sparse_mod

  implicit none

  contains

  subroutine make_sparse_2d(model,perc,flag,data)
    real,dimension(:,:)                  :: model,data
    real                                 :: perc,temp,temp1,temp2 ! perc is in percentage to eliminate (like 100, 50, or 20)
    integer                              :: n1,n2,n,eliminated,ind1,ind2
    integer                              :: to_eliminate !nb of points to eliminate in total
    real,dimension(2)                    :: rand
    integer,dimension(:,:)               :: flag

    n1 = size(model,1)
    n2 = size(model,2)
    n  = n1 * n2
    data = model
    temp = 1.0 * n * perc/100.
    to_eliminate = temp
    eliminated = 0
 
    do while (eliminated .lt. to_eliminate)
      call random_number(rand)
      temp1 = n1 * rand(1)
      ind1 = temp1 + 1
      temp2 = n2 * rand(2)
      ind2 = temp2 + 1
      if (flag(ind1,ind2) .eq. 1) then
        flag(ind1,ind2) = 0
        data(ind1,ind2) = 0.
        eliminated = eliminated + 1
        !write(0,*), "eliminated", eliminated
      end if
    end do
        
  end subroutine
  
end module
