program plot_just_exp_cov

  use sep
  use exp_cov_mod
 
  implicit none
  
  real                                    :: distance,nugget,range,sill,alpha,power
  real,dimension(:),allocatable           :: covariance_function
  integer                                 :: i,n1,norm
  real                                    :: o1,d1
  real,dimension(:),allocatable           :: nb_sample_range

  call sep_init()

  call from_param("n1",n1)
  o1 = 0
  d1 = 1

  call from_param("nugget",nugget)
  call from_param("range_variogram",range)
  call from_param("sill",sill)
  call from_param("alpha",alpha)
  call from_param("power",power)
  call from_param("norm",norm)

  allocate(covariance_function(n1))
  allocate(nb_sample_range(n1))
  do i=1,n1
    nb_sample_range(i) = o1 + (i-1) * d1
  end do

  do i=1,n1    
    covariance_function(i) = get_covariance(nb_sample_range(i),nugget,range,sill,alpha,power)
  end do

  if (norm .eq. 1) then
    covariance_function = covariance_function/sill
  end if

  call sep_write(covariance_function)

  call to_history("n1",n1)
  call to_history("o1",0)
  call to_history("d1",1)

  call to_history("n2",1)
  call to_history("o2",0)
  call to_history("d2",0)

  call sep_close()

end program


