program program_test_sparse

  use sep
  use make_sparse_mod

  implicit none

  real,dimension(:,:),allocatable        :: sparse_data,flag_real,data
  integer                                :: n1,n2,i,j,counter,n
  real                                   :: o1,o2,d1,d2,perc,rand
  integer,dimension(:,:),allocatable     :: flag_matrix

  call sep_init()

  call from_history("n1",n1)
  call from_history("d1",d1)
  call from_history("o1",o1)
  call from_history("n2",n2)
  call from_history("d2",d2)
  call from_history("o2",o2)

  call from_param("perc",perc)

  allocate(data(n1,n2))
  allocate(flag_matrix(n1,n2))
  allocate(sparse_data(n1,n2))
  allocate(flag_real(n1,n2))

  call sep_read(data)

  flag_matrix = 1

  call make_sparse_2d(data,perc,flag_matrix,sparse_data)

  counter = 0
  do i=1,n1
    do j=1,n2
      counter = counter + flag_matrix(i,j)
    end do
  end do

  flag_real = flag_matrix * 1.0
  write(0,*) "total nb of points",n1*n2
  write(0,*) "remaining points:",counter

  call sep_write(flag_real,"flag")
  call sep_write(sparse_data)

  call to_history("n1",n1)
  call to_history("o1",o1)
  call to_history("d1",d1)
  call to_history("n2",n2)
  call to_history("o2",o2)
  call to_history("d2",d2)

  call to_history("n1",n1,"flag")
  call to_history("o1",o1,"flag")
  call to_history("d1",d1,"flag")
  call to_history("n2",n2,"flag")
  call to_history("o2",o2,"flag")
  call to_history("d2",d2,"flag")

  call sep_close() 

end program
