program program_test_scan_2d

  use scan_mod
  use sep

  implicit none

  integer                               :: nz,nx,n_max,n_min,range,i,j,nb_samples
  real                                  :: oz,dz,ox,dx
  real,dimension(:,:),allocatable       :: flag,samples,new_flag,samples_1d_up,samples_1d_down,flag_1d     
  integer,dimension(2)                  :: position  
  logical                               :: stop_krig
  integer,dimension(:),allocatable      :: nb_samples_1d

  call sep_init()

  call from_history("n1", nz)
  call from_history("n2", nx) 

  call from_param("n_max",n_max)
  call from_param("n_min",n_min)
  call from_param("range",range)
  
  allocate(flag(nz,nx))
  allocate(new_flag(nz,nx))
  allocate(nb_samples_1d(nz))

  call sep_read(flag)

  position(1) = 4
  position(2) = 13

  call scan2d_4(range,position,n_min,n_max,flag,stop_krig,samples,nb_samples)

  new_flag = 0.
  write(0,*) "nb of samples",nb_samples

  do i=1,nb_samples
    new_flag(samples(i,1),samples(i,2))=1
  end do


  write(0,*) "stat", stop_krig

  call to_history("n1", nz)
  call to_history("d1", 1.0)
  call to_history("o1", 1.0)  
  call to_history("n2", nx)
  call to_history("d2", 1.0)
  call to_history("o2", 1.0)  

  call sep_write(new_flag)
  call sep_close()
  
end program
