program program_test_scan_1d

  use scan_mod
  use sep

  implicit none

  integer                               :: nz,nx,n_max,n_min,range,i,j,up
  real                                  :: oz,dz,ox,dx
  real,dimension(:,:),allocatable       :: temp,samples_up,samples_down,flag_1d     
  integer,dimension(2)                  :: position  
  logical,dimension(:),allocatable      :: stop_krig
  integer,dimension(:),allocatable      :: nb_samples_down,nb_samples_up
  integer,dimension(:,:),allocatable    :: flag

  call sep_init()

  call from_history("n1", nz)
  call from_history("n2", nx) 

  call from_param("n_max",n_max)
  call from_param("n_min",n_min)
  call from_param("range",range)
  call from_param("up",up)
  
  allocate(temp(nz,nx))
  allocate(flag(nz,nx))
  allocate(flag_1d(nz,nx))
  allocate(nb_samples_up(nz))
  allocate(nb_samples_down(nz))
  allocate(stop_krig(nz))

  call sep_read(temp)
  flag = temp

  position(1) = 10
  position(2) = 13
  write(0,*) "we are at column:",position(1) 

  if (up .eq. 1) then
    allocate(samples_up(nz,n_max))
    do i=1,nz
      call scan1d_up(range,position(1),n_min,n_max,flag(i,:),stop_krig(i),samples_up(i,:),nb_samples_up(i))
    end do
    flag_1d = 0.
    do i=1,nz
      do j=1,nb_samples_up(i)
        write(0,*), "nb of samp at line",i,nb_samples_up(i)
        flag_1d(i,samples_up(i,j)) = 1
      end do
    end do

  else 
    allocate(samples_down(nz,n_max))
    do i=1,nz
      call scan1d_down(range,position(1),n_min,n_max,flag(i,:),stop_krig(i),samples_down(i,:),nb_samples_down(i))
    end do
    flag_1d = 0.
    do i=1,nz
      do j=1,nb_samples_down(i)
        write(0,*), "nb of samp at line",i,":",nb_samples_down(i)
        write(0,*), "coord at row",i,samples_down(i,j)
        flag_1d(i,samples_down(i,j)) = 1
      end do
    end do
  end if
   
  do i=1,nz
    write(0,*) "STOP KRIG?", i,stop_krig(i)
  end do

  call to_history("n1", nz)
  call to_history("d1", 1.0)
  call to_history("o1", 1.0)  
  call to_history("n2", nx)
  call to_history("d2", 1.0)
  call to_history("o2", 1.0)  

  call sep_write(flag_1d)
  call sep_close()
  
end program
