program program_test_scan_2d

  use scan_mod
  use sep

  implicit none

  integer                               :: nz,nx,n_max,n_min,range,i,j,nb_samples,quadrant,x,z,total_nb_samples
  real                                  :: oz,dz,ox,dx
  real,dimension(:,:),allocatable       :: temp,new_flag,sparse_data    
  integer,dimension(2)                  :: position  
  logical                               :: stop_krig
  integer,dimension(:,:),allocatable    :: flag,samples,samp_position
  real,dimension(:),allocatable         :: samp_values

  call sep_init()

  call from_history("n1", nz)
  call from_history("n2", nx) 

  call from_param("n_max",n_max)
  call from_param("n_min",n_min)
  call from_param("range",range)
  call from_param("quadrant",quadrant)
  call from_param("z",z)
  call from_param("x",x)
  
  allocate(flag(nz,nx))
  allocate(temp(nz,nx))
  allocate(sparse_data(nz,nx))
  allocate(new_flag(nz,nx))
  allocate(samples(n_max,2))

  call sep_read(temp)
  flag = temp
  sparse_data = temp

  position(1) = z
  position(2) = x
  temp(z,x) = -1.0

  select case (quadrant)
    case(1)
      call scan2d_1(range,position,n_min,n_max,flag,stop_krig,samples,nb_samples)
    case(2)
      call scan2d_2(range,position,n_min,n_max,flag,stop_krig,samples,nb_samples)
    case(3)
      call scan2d_3(range,position,n_min,n_max,flag,stop_krig,samples,nb_samples)
    case(4)
      call scan2d_4(range,position,n_min,n_max,flag,stop_krig,samples,nb_samples)
    case(5)
      call scan2d(range,position,n_min,n_max,flag,stop_krig,samp_position,samp_values,sparse_data)
      total_nb_samples = size(samp_values)
  end select

  if (quadrant .eq. 5) then

    new_flag = 0.
    write(0,*) "total nb of samples",total_nb_samples
    do i=1,total_nb_samples
      new_flag(samp_position(i,1),samp_position(i,2)) = 1.0
    end do
    new_flag(z,x) = -1.0

  else 

    new_flag = 0.
    write(0,*) "nb of samples in quadrant",quadrant,nb_samples
    do i=1,nb_samples
      new_flag(samples(i,1),samples(i,2))=1.0
    end do
    new_flag(z,x) = -1.0

  end if

  if (stop_krig) then
    write(0,*) "stop kriging"
  else 
    write(0,*) "perform kriging"
  end if

  call to_history("n1", nz)
  call to_history("d1", 1.0)
  call to_history("o1", 1.0)  
  call to_history("n2", nx)
  call to_history("d2", 1.0)
  call to_history("o2", 1.0)  

  call to_history("n1", nz,"fspike")
  call to_history("d1", 1.0,"fspike")
  call to_history("o1", 1.0,"fspike")  
  call to_history("n2", nx,"fspike")
  call to_history("d2", 1.0,"fspike")
  call to_history("o2", 1.0,"fspike") 

  call sep_write(temp,"fspike")
  call sep_write(new_flag)
  call sep_close()
  
end program
