program program_test_sparse

  use sep
  use make_sparse_mod

  implicit none

  real,dimension(:,:),allocatable        :: fake_data,sparse,flag_real
  integer                                :: n1,n2,i,j,counter,n
  real                                   :: o1,o2,d1,d2,perc,rand
  integer,dimension(:,:),allocatable     :: temp,flag_matrix

  call sep_init()

  call from_param("perc",perc)
  call from_param("size",n)

  n1 = n
  n2 = n
  o1 = 1
  o2 = 1
  d1 = 1
  d2 = 1

  allocate(fake_data(n1,n2))
  allocate(flag_matrix(n1,n2))
  allocate(sparse(n1,n2))
  allocate(flag_real(n1,n2))
  flag_matrix = 1
  perc = 80

  do i=1,n1
    do j=1,n2
      call random_number(rand)
      fake_data(i,j) = rand * 100
    end do
  end do

  call make_sparse_2d(fake_data,perc,flag_matrix,sparse)

  counter = 0
  do i=1,n1
    do j=1,n2
      counter = counter + flag_matrix(i,j)
    end do
  end do

  flag_real = flag_matrix * 1.0
  !write(0,*) "remaining points:",counter

  call sep_write(flag_real,"flag")
  call sep_write(fake_data,"original")
  call sep_write(sparse)

  call to_history("n1",n1)
  call to_history("o1",1)
  call to_history("d1",1)
  call to_history("n2",n2)
  call to_history("o2",1)
  call to_history("d2",1)

  call to_history("n1",n1,"original")
  call to_history("o1",1,"original")
  call to_history("d1",1,"original")
  call to_history("n2",n2,"original")
  call to_history("o2",1,"original")
  call to_history("d2",1,"original")

  call to_history("n1",n1,"flag")
  call to_history("o1",1,"flag")
  call to_history("d1",1,"flag")
  call to_history("n2",n2,"flag")
  call to_history("o2",1,"flag")
  call to_history("d2",1,"flag")

  call sep_close() 

end program
