program reduce

  use sep
 
  implicit none

  integer                               :: nz,nx,reduce_by,new_nz,new_nx,i,j,zone
  real                                  :: oz,dz,ox,dx,new_ox,new_oz
  real,dimension(:,:),allocatable       :: data,small_data
  integer                               :: custom,iz_min,iz_max,ix_min,ix_max
  
  call sep_init()
  call from_param("custom",custom)

  if (custom .eq. 0) then

    call from_history("n1",nz) 
    call from_history("o1",oz)
    call from_history("d1",dz)
    call from_history("n2",nx) 
    call from_history("o2",ox)
    call from_history("d2",dx)
    call from_param("reduce_by",reduce_by)
    call from_param("zone",zone)

    allocate(data(nz,nx))
    call sep_read(data)

    new_nz = nz/reduce_by
    new_nx = nx/reduce_by

    write(0,*) "nz",nz
    write(0,*) "new nz",new_nz
    write(0,*) "nx",nx
    write(0,*) "new nx",new_nx

    allocate(small_data(new_nz,new_nx))

    select case(zone)

      case(1)
      do i=1,new_nz
        do j=1,new_nx
          small_data(i,j) = data(i,j)
        end do
      end do

      case(2)
      do i=1,new_nz
        do j=nx-new_nx+1,nx
          small_data(i,j-nx+new_nx) = data(i,j)
        end do
      end do

      case(3)
      do i=nz-new_nz+1,nz
        do j=nx-new_nx+1,nx
          small_data(i-nz+new_nz,j-nx+new_nx) = data(i,j)
        end do
      end do

      case(4)
      do i=nz-new_nz+1,nz
        do j=1,new_nx
          small_data(i-nz+new_nz,j) = data(i,j)
        end do
      end do
    end select


    call sep_write(small_data)

    call to_history("n1",new_nz)
    call to_history("o1",oz)
    call to_history("d1",dz)
    call to_history("n2",new_nx)
    call to_history("o2",ox)
    call to_history("d2",dx)

  else
  
    call from_history("n1",nz) 
    call from_history("o1",oz)
    call from_history("d1",dz)
    call from_history("n2",nx) 
    call from_history("o2",ox)
    call from_history("d2",dx)
    call from_param("zmin",iz_min)
    call from_param("zmax",iz_max)
    call from_param("xmin",ix_min)
    call from_param("xmax",ix_max)
    
    allocate(data(nz,nx))
    call sep_read(data)

    new_nz = iz_max-iz_min+1
    new_nx = ix_max-ix_min+1
    new_oz = oz + (iz_min-1) * dz
    new_ox = ox + (ix_min-1) * dx

    allocate(small_data(new_nz,new_nx))
    
    do i=1,new_nz
      do j=1,new_nx
        small_data(i,j) = data(iz_min+i-1,ix_min+j-1)
      end do
    end do

    call sep_write(small_data)
    
    call to_history("n1",new_nz)
    call to_history("o1",new_oz)
    call to_history("d1",dz)
    call to_history("n2",new_nx)
    call to_history("o2",new_ox)
    call to_history("d2",dx)

  end if

    call sep_close()
  
end program
