program semblance_program

  use sep
  use vel_analysis_mod
 
  implicit none

  integer                         :: adj,adj2,nt,nx,nvel,i,j ! nb of time, nb of offsets, nb of velocity values    
  real                            :: ot,dt,ox,dx,ovel,dvel
  real,allocatable,dimension(:,:) :: dat,dat2,mod ! declaring the model and data matrices

  ! inputing the parameters manually
  nvel=400
  ovel=1.450
  dvel=0.0045
  adj=1
  adj2=0

  call sep_init() ! call this subroutine in order to be able to use the sep library

  ! importing parameters from standard input
  call from_history("n1", nt) 
  call from_history("o1", ot)
  call from_history("d1", dt)
  call from_history("n2", nx) 
  call from_history("o2", ox)
  call from_history("d2", dx)

  allocate(dat(nt,nx))
  allocate(mod(nt,nvel))
  allocate(dat2(nt,nx))
  
  ! reading the data from input.H file and assigning the values to dat variable
  call sep_read(dat)

  ! calling the adjoint of the modeling operator 
  call vel_analysis(adj,ot,dt,nt,ox,dx,nx,ovel,dvel,nvel,mod,dat)

  ! outputting the parameters to .H file
  call to_history("n1", nt)
  call to_history("o1", ot)
  call to_history("d1", dt)
  call to_history("n2", nvel)
  call to_history("o2", ovel)
  call to_history("d2", dvel)

  call to_history("eout", 4) ! 4 is the nb of bytes to store the information
  call to_history("label1","tau(s)")
  call to_history("label2", "velocity")
  call sep_write(mod) ! writing the data from mod to ouput.H file

  call sep_close()

end program
