program smoothing

  use sep

  implicit none

  real,dimension(:),allocatable        :: data,sparse_data,rflag
  integer                              :: i,j,n,n_sparse,eliminated
  real                                 :: perc,T,rand,x
 
  call sep_init()

  ! length of signal
  n = 1000

  ! period
  T = 200

  ! percentage to remove
  perc = 95
  n_sparse = n * perc/100
  write(0,*) "to eliminate",n_sparse

  allocate(data(n))
  allocate(sparse_data(n))
  allocate(rflag(n))

  data = 0
  rflag = 1

  ! cosine function
  do i=1,n
    data(i) = cos(2*3.14*1/T*i)
  end do
  sparse_data = data
  eliminated = 0

  do while (eliminated .lt. n_sparse)
    call random_number(rand)
    x =  rand * (n-1)
    i = 1.5 + x
    if (rflag(i) .eq. 1) then
      rflag(i) = 0
      sparse_data(i) = 0
      eliminated = eliminated + 1
      write(0,*) "eliminated", eliminated
    end if
  end do
    
  
  call sep_write(data)
  call sep_write(sparse_data,"sparse")
  call sep_write(rflag,"flag")

  call to_history("n1",n)
  call to_history("o1",0)
  call to_history("d1",1)

  call to_history("n1",n,"sparse")
  call to_history("o1",0,"sparse")
  call to_history("d1",1,"sparse")

  call to_history("n1",n,"flag")
  call to_history("o1",0,"flag")
  call to_history("d1",1,"flag")
  call sep_close
    
end program
