module synmarine1_mod

  implicit none
  contains

  subroutine synmarin1(data, nt, nh, ny, nz)
    integer         :: nt, nh, ny, nz, ns, iseed
    integer         :: it, ih, iy, is, iz
    real            :: data(nt, nh, ny), refl(nz, ny), depth(nz)
    real            :: layer, rand01

    iseed = 1992
    ns = ny
    do iz=1,nz
      ! 0 < rand01() < 1
      depth(iz) = nt*rand01(iseed) ! Reflector depth
      layer = 2.*rand01(iseed) - 1. ! Reflector strength
      do iy=1,ny
        ! Impose texture on layer
        refl(iz, iy) = layer*(1.+rand01(iseed))
      enddo
    enddo

    data = 0.

!!! You need to change the code for Common-Midpoint gather !!!

    do iy=1,ny ! CMP 
      do ih=1,nh  ! half-offset h = (g-s)/2
        do iz=1,nz ! depth
          ! Add hyperbola for each layer
          !iy = (ns-is)+(ih-1) ! y = midpoint
          !iy = 1 + (iy-ny*(iy/ny)) ! periodic with midpoint
          it = 1 + sqrt(depth(iz)**2 + 25.*(ih-1)**2)
          if(it <= nt) then
            data(it, ih, iy) = data(it, ih, iy) + refl(iz, iy)
          endif
        enddo
      enddo
    enddo

  end subroutine

end module

