program test_gaussian_cdf

  use sep
  use stats_mod

  implicit none

  real                               :: rand,o_cdf,d_cdf,o_samp,d_samp,p_min,p_max,test,mean,avg,sig
  integer                            :: n1,n2,i,j,n_cdf,nb_picks
  real,dimension(:,:),allocatable    :: data
  real,dimension(:),allocatable      :: cdf,coord,x_test

  call sep_init()

  call from_param("n1",n1)
  call from_param("n2",n2)
  allocate(data(n1,n2))

  o_cdf = 0 
  d_cdf = 1.0
  n_cdf = 101

  allocate(cdf(n_cdf))

  do i=1,n1
    do j=1,n2
      call random_number(rand)
      data(i,j) = rand * 100
      write(0,*) "i,j",data(i,j)
    end do
  end do

  avg = average(data)
  sig = stand_dev(data,avg)
  write(0,*) "average input", avg
  write(0,*) "sigma input", sig
  cdf = gaussian_cdf(o_cdf,d_cdf,n_cdf,avg,sig)

  p_min = cdf(1)
  p_max = cdf(n_cdf)

  write(0,*),"p min",p_min
  write(0,*),"p max",p_max


  !!! picking a random value !!!
  nb_picks = 100
  allocate(x_test(nb_picks))

  do i=1,nb_picks
    call random_number(test)
    x_test(i) = mc_gaussian(cdf,o_cdf,d_cdf,n_cdf)
  end do

    ! calculating mean
    mean = 0.
    do i=1,nb_picks
        mean = mean + x_test(i)
    end do    
    mean = mean/nb_picks 
    write(0,*) "mean rand picks",mean  

  call to_history("n1",n_cdf)
  call to_history("o1",o_cdf)
  call to_history("d1",d_cdf)

  call to_history("n2",1)
  call to_history("o2",0.0)
  call to_history("d2",0.0)

  call to_history("n1",nb_picks,"picks")
  call to_history("o1",1,"picks")
  call to_history("d1",1,"picks")

  call to_history("n2",1,"picks")
  call to_history("o2",0.0,"picks")
  call to_history("d2",0.0,"picks")
  
  call sep_write(cdf)
  call sep_write(x_test,"picks")

  call sep_close()  

end program
