program test_mc_method

  use sep
  use scan_mod
  use stats_mod

  implicit none

  real    :: mean,sig,o,d,f
  integer :: n,i,nb
  real,dimension(:),allocatable :: cdf,data
  
  call sep_init()

  nb = 250000
  mean = 0.002
  sig = 0.1208
  n = 100
  o = mean - 3*sig
  f = mean + 3*sig
  d = (f-o)/n
 
  allocate(cdf(n))
  allocate(data(nb))
  cdf = gaussian_cdf(o,d,n,mean,sig)
 
  do i=1,nb
    data(i) = mc_gaussian(cdf,o,d,n)
  end do

  call sep_write(data)
  call to_history("n1",nb)
  call to_history("o1",1)
  call to_history("d1",1)

  call sep_close()

end program

