module useful_functions

  implicit none

  contains
  
   subroutine vel_analysis(adj,t0,dt,nt,x0,dx,nx,v0,dv,nv,model,data)
    integer                         :: adj,nt,nx,nv,ntau
    real                            :: t0,dt,x0,dx,v0,dv,tau0,dtau
    real,dimension(:,:)             :: model,data
    integer                         :: it,ix,iv,itau
    real                            :: t,x,v,tau,weight

    tau0=t0;dtau=dt;ntau=nt  
    if (adj == 0) then
      data=0.
    else
      model=0.
    end if 
    do iv=1,nv
      v=v0+(iv-1)*dv
      do itau=1,ntau
        tau=tau0+(itau-1)*dtau
        do ix=1,nx
          x=x0+(ix-1)*dx
          t=sqrt(tau*tau+(x/v)*(x/v))
          it=(t-t0)/dt+1.5
          if (it<=nt) then
            weight=tau/t*1/sqrt(t)*sqrt(x/v)
            if(adj == 0) then
              data(it,ix) = data(it,ix)+model(itau,iv)*weight
            else 
              model(itau,iv) = model(itau,iv) + data(it,ix)*weight  
            end if
          end if
        end do 
      end do
    end do  
  end subroutine

end module
